//                           _       _
// __      _____  __ ___   ___  __ _| |_ ___
// \ \ /\ / / _ \/ _` \ \ / / |/ _` | __/ _ \
//  \ V  V /  __/ (_| |\ V /| | (_| | ||  __/
//   \_/\_/ \___|\__,_| \_/ |_|\__,_|\__\___|
//
//  Copyright © 2016 - 2022 SeMI Technologies B.V. All rights reserved.
//
//  CONTACT: hello@semi.technology
//

// Code generated by go-swagger; DO NOT EDIT.

package objects

// This file was generated by the swagger tool.
// Editing this file might prove futile when you re-run the swagger generate command

import (
	"fmt"
	"io"

	"github.com/go-openapi/runtime"
	"github.com/go-openapi/strfmt"

	"github.com/semi-technologies/weaviate/entities/models"
)

// ObjectsDeleteReader is a Reader for the ObjectsDelete structure.
type ObjectsDeleteReader struct {
	formats strfmt.Registry
}

// ReadResponse reads a server response into the received o.
func (o *ObjectsDeleteReader) ReadResponse(response runtime.ClientResponse, consumer runtime.Consumer) (interface{}, error) {
	switch response.Code() {
	case 204:
		result := NewObjectsDeleteNoContent()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return result, nil
	case 401:
		result := NewObjectsDeleteUnauthorized()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 403:
		result := NewObjectsDeleteForbidden()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 404:
		result := NewObjectsDeleteNotFound()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result
	case 500:
		result := NewObjectsDeleteInternalServerError()
		if err := result.readResponse(response, consumer, o.formats); err != nil {
			return nil, err
		}
		return nil, result

	default:
		return nil, runtime.NewAPIError("unknown error", response, response.Code())
	}
}

// NewObjectsDeleteNoContent creates a ObjectsDeleteNoContent with default headers values
func NewObjectsDeleteNoContent() *ObjectsDeleteNoContent {
	return &ObjectsDeleteNoContent{}
}

/*
ObjectsDeleteNoContent handles this case with default header values.

Successfully deleted.
*/
type ObjectsDeleteNoContent struct {
}

func (o *ObjectsDeleteNoContent) Error() string {
	return fmt.Sprintf("[DELETE /objects/{id}][%d] objectsDeleteNoContent ", 204)
}

func (o *ObjectsDeleteNoContent) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewObjectsDeleteUnauthorized creates a ObjectsDeleteUnauthorized with default headers values
func NewObjectsDeleteUnauthorized() *ObjectsDeleteUnauthorized {
	return &ObjectsDeleteUnauthorized{}
}

/*
ObjectsDeleteUnauthorized handles this case with default header values.

Unauthorized or invalid credentials.
*/
type ObjectsDeleteUnauthorized struct {
}

func (o *ObjectsDeleteUnauthorized) Error() string {
	return fmt.Sprintf("[DELETE /objects/{id}][%d] objectsDeleteUnauthorized ", 401)
}

func (o *ObjectsDeleteUnauthorized) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewObjectsDeleteForbidden creates a ObjectsDeleteForbidden with default headers values
func NewObjectsDeleteForbidden() *ObjectsDeleteForbidden {
	return &ObjectsDeleteForbidden{}
}

/*
ObjectsDeleteForbidden handles this case with default header values.

Forbidden
*/
type ObjectsDeleteForbidden struct {
	Payload *models.ErrorResponse
}

func (o *ObjectsDeleteForbidden) Error() string {
	return fmt.Sprintf("[DELETE /objects/{id}][%d] objectsDeleteForbidden  %+v", 403, o.Payload)
}

func (o *ObjectsDeleteForbidden) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ObjectsDeleteForbidden) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}

// NewObjectsDeleteNotFound creates a ObjectsDeleteNotFound with default headers values
func NewObjectsDeleteNotFound() *ObjectsDeleteNotFound {
	return &ObjectsDeleteNotFound{}
}

/*
ObjectsDeleteNotFound handles this case with default header values.

Successful query result but no resource was found.
*/
type ObjectsDeleteNotFound struct {
}

func (o *ObjectsDeleteNotFound) Error() string {
	return fmt.Sprintf("[DELETE /objects/{id}][%d] objectsDeleteNotFound ", 404)
}

func (o *ObjectsDeleteNotFound) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	return nil
}

// NewObjectsDeleteInternalServerError creates a ObjectsDeleteInternalServerError with default headers values
func NewObjectsDeleteInternalServerError() *ObjectsDeleteInternalServerError {
	return &ObjectsDeleteInternalServerError{}
}

/*
ObjectsDeleteInternalServerError handles this case with default header values.

An error has occurred while trying to fulfill the request. Most likely the ErrorResponse will contain more information about the error.
*/
type ObjectsDeleteInternalServerError struct {
	Payload *models.ErrorResponse
}

func (o *ObjectsDeleteInternalServerError) Error() string {
	return fmt.Sprintf("[DELETE /objects/{id}][%d] objectsDeleteInternalServerError  %+v", 500, o.Payload)
}

func (o *ObjectsDeleteInternalServerError) GetPayload() *models.ErrorResponse {
	return o.Payload
}

func (o *ObjectsDeleteInternalServerError) readResponse(response runtime.ClientResponse, consumer runtime.Consumer, formats strfmt.Registry) error {

	o.Payload = new(models.ErrorResponse)

	// response payload
	if err := consumer.Consume(response.Body(), o.Payload); err != nil && err != io.EOF {
		return err
	}

	return nil
}
